=== debian/control ===
Source: ulfius
Section: devel
Priority: optional
Maintainer: Thorsten Alteholz <debian@alteholz.de>
Build-Depends: debhelper (>= 10)
	, libmicrohttpd-dev
	, libcurl4-gnutls-dev
	, libjansson-dev
	, liborcania-dev
	, libyder-dev
Standards-Version: 4.0.0
Homepage: https://github.com/babelouest/ulfius
#Vcs-Git: https://anonscm.debian.org/collab-maint/oauth2-server.git
#Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/oauth2-server.git

Package: libulfius2.1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Web Framework for REST Applications in C
 Based on GNU Libmicrohttpd for the backend web server, Jansson for the 
 json manipulation library, and Libcurl for the http/smtp client API.
 .
 Used to facilitate creation of web applications in C programs with a 
 small memory footprint, as in embedded systems applications.
 .
 One can create webservices in HTTP or HTTPS mode, stream data, or 
 implement server websockets.

Package: libulfius-dev
Architecture: any
Section: libdevel
Depends: libulfius2.1 (= ${binary:Version})
        , ${misc:Depends}
        , liborcania-dev
        , libyder-dev
Description: Web Framework for REST Applications in - development
 Based on GNU Libmicrohttpd for the backend web server, Jansson for the 
 json manipulation library, and Libcurl for the http/smtp client API.
 .
 Used to facilitate creation of web applications in C programs with a 
 small memory footprint, as in embedded systems applications.
 .
 One can create webservices in HTTP or HTTPS mode, stream data, or 
 implement server websockets.
 .
 This package contains the development files.
