=== src/Makefile ===
--- 
+++ 
@@ -23,20 +23,20 @@
 LIBYDER_LOCATION=../lib/yder/src
 PREFIX=/usr/local
 CC=gcc
-CFLAGS=-c -fPIC -Wall -D_REENTRANT -I$(PREFIX)/include -I$(LIBORCANIA_LOCATION) -I$(LIBYDER_LOCATION) $(ADDITIONALFLAGS) $(JANSSONFLAG) $(CURLFLAG) $(WEBSOCKETFLAG)
+CFLAGS=-c -pedantic -std=gnu99 -fPIC -Wall -D_REENTRANT -I$(PREFIX)/include -I$(LIBORCANIA_LOCATION) -I$(LIBYDER_LOCATION) $(ADDITIONALFLAGS) $(JANSSONFLAG) $(CURLFLAG) $(WEBSOCKETFLAG)
 LIBS=-L$(PREFIX)/lib -L$(LIBORCANIA_LOCATION) -L$(LIBYDER_LOCATION) -lc -lmicrohttpd -lyder -lorcania -lpthread
 OUTPUT=libulfius.so
-VERSION=2.1
+VERSION=2.2.4
 
-ifneq (($(JANSSONFLAG)),"")
+ifndef JANSSONFLAG
 LJANSSON=-ljansson
 endif
 
-ifneq (($(CURLFLAG)),"")
+ifndef CURLFLAG
 LCURL=-lcurl
 endif
 
-ifneq (($(WEBSOCKETFLAG)),"")
+ifndef WEBSOCKETFLAG
 LWEBSOCKET=-lgnutls
 endif
 
@@ -46,34 +46,41 @@
 	$(CC) -shared -Wl,-soname,$(OUTPUT) -o $(OUTPUT).$(VERSION) ulfius.o u_map.o u_request.o u_response.o u_send_request.o u_websocket.o $(LIBS) $(LJANSSON) $(LCURL) $(LWEBSOCKET)
 	ln -sf $(OUTPUT).$(VERSION) $(OUTPUT)
 
-ulfius.o: ulfius.h ulfius.c
+libulfius.a: ulfius.o u_map.o u_request.o u_response.o u_send_request.o u_websocket.o
+	ar rcs libulfius.a ulfius.o u_map.o u_request.o u_response.o u_send_request.o u_websocket.o
+
+ulfius.o: ulfius.h u_private.h ulfius.c
 	$(CC) $(CFLAGS) ulfius.c
 
-u_map.o: ulfius.h u_map.c
+u_map.o: ulfius.h u_private.h u_map.c
 	$(CC) $(CFLAGS) u_map.c
 
-u_request.o: ulfius.h u_request.c
+u_request.o: ulfius.h u_private.h u_request.c
 	$(CC) $(CFLAGS) u_request.c
 
-u_response.o: ulfius.h u_response.c
+u_response.o: ulfius.h u_private.h u_response.c
 	$(CC) $(CFLAGS) u_response.c
 
-u_websocket.o: ulfius.h u_websocket.c
+u_websocket.o: ulfius.h u_private.h u_websocket.c
 	$(CC) $(CFLAGS) u_websocket.c
 
-u_send_request.o: ulfius.h u_send_request.c
+u_send_request.o: ulfius.h u_private.h u_send_request.c
 	$(CC) $(CFLAGS) u_send_request.c
 
 clean:
-	rm -f *.o *.so $(OUTPUT) $(OUTPUT).*
+	rm -f *.o *.so *.a $(OUTPUT) $(OUTPUT).*
 
 install: all
 	cp $(OUTPUT).$(VERSION) $(PREFIX)/lib
 	cp ulfius.h $(PREFIX)/include
-	ldconfig
+	-ldconfig
+
+static-install: static
+	cp libulfius.a $(PREFIX)/lib
+	cp ulfius.h $(PREFIX)/include
 
 uninstall:
-	rm -f $(PREFIX)/lib/$(OUTPUT)
+	rm -f $(PREFIX)/lib/$(OUTPUT) libulfius.a
 	rm -f $(PREFIX)/lib/$(OUTPUT).*
 	rm -f $(PREFIX)/include/ulfius.h
 
@@ -84,3 +91,11 @@
 release: ADDITIONALFLAGS=-O3
 
 release: libulfius.so
+
+static: ADDITIONALFLAGS=-O3
+
+static: libulfius.a
+
+static-debug: ADDITIONALFLAGS=-DDEBUG -g -O0
+
+static-debug: libulfius.a
