=== debian/changelog ===
ulfius (2.2.4-1) unstable; urgency=medium

  * New upstream release
  * debian/control: bump standard to 4.1.3 (no changes)
  * debian/control: use dh11

 -- Thorsten Alteholz <debian@alteholz.de>  Fri, 26 Jan 2018 14:54:14 +0100

ulfius (2.2-1) unstable; urgency=medium

  * New upstream release
  * debian/control: bump standard, no changes
  * debian/control: handle SONAME bump

 -- Thorsten Alteholz <debian@alteholz.de>  Tue, 21 Nov 2017 18:56:19 +0100

ulfius (2.1.2-1) unstable; urgency=medium

  * New upstream release
  * debian/control: bump standard to 4.1.0 (no changes)
  * debian/control: add VCS URLs
  * debian/control: set team as maintainer

 -- Thorsten Alteholz <debian@alteholz.de>  Sun, 03 Sep 2017 19:06:24 +0200
