=== debian/watch ===
version=4

# https://github.com/babelouest/ulfius
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%ulfius-$1.tar.gz%" \
   https://github.com/babelouest/ulfius/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
