=== debian/changelog ===
ulfius (2.3.7-1) unstable; urgency=medium

  * New upstream release

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 14 Jul 2018 10:24:07 -0400

ulfius (2.3.6-1) unstable; urgency=medium

  * New upstream release

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 16 Jun 2018 07:31:13 -0400

ulfius (2.3.5-1) unstable; urgency=medium

  * New upstream release

 -- Nicolas Mora <nicolas@babelouest.org>  Fri, 01 Jun 2018 07:35:12 -0400

ulfius (2.3.4-3) unstable; urgency=medium

  * Fix include ulfius macro in examples

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 28 Apr 2018 14:16:16 -0400

ulfius (2.3.4-2) unstable; urgency=medium

  * Fix quilt-patch-missing-description lintian warning

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 28 Apr 2018 14:02:17 -0400

ulfius (2.3.4-1) unstable; urgency=medium

  * New upstream release
  * Install examples and README.md
  * debian/rules: use cmake as buildsystem
  * debian/copyright: add cmake scripts
  * debian/patches: Adapt examples for debian package

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 28 Apr 2018 09:59:46 -0400

ulfius (2.3.3-1) unstable; urgency=medium

  * New upstream release

 -- Nicolas Mora <mail@babelouest.org>  Mon, 02 Apr 2018 09:51:11 -0400
