=== debian/control ===
--- 
+++ 
@@ -3,18 +3,20 @@
 Priority: optional
 Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
 Uploaders: Thorsten Alteholz <debian@alteholz.de>
+          , Nicolas Mora <nicolas@babelouest.org>
 Build-Depends: debhelper (>= 11)
 	, libmicrohttpd-dev
 	, libcurl4-gnutls-dev
 	, libjansson-dev
 	, liborcania-dev
 	, libyder-dev
+  , cmake
 Standards-Version: 4.1.3
 Homepage: https://github.com/babelouest/ulfius
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-iot/ulfius.git
-Vcs-Git: https://anonscm.debian.org/git/debian-iot/ulfius.git
+Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/ulfius.git
+Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/ulfius.git
 
-Package: libulfius2.2
+Package: libulfius2.3
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -31,10 +33,11 @@
 Package: libulfius-dev
 Architecture: any
 Section: libdevel
-Depends: libulfius2.2 (= ${binary:Version})
+Depends: libulfius2.3 (= ${binary:Version})
         , ${misc:Depends}
         , liborcania-dev
         , libyder-dev
+        , libjs-jquery
 Description: Web Framework for REST Applications in - development
  Based on GNU Libmicrohttpd for the backend web server, Jansson for the
  json manipulation library, and Libcurl for the http/smtp client API.
